import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { WechatDeposit, WechatDepositParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询押金
 */
export async function pageWechatDeposit(params: WechatDepositParam) {
  const res = await request.get<ApiResult<PageResult<WechatDeposit>>>(
    MODULES_API_URL + '/shop/wechat-deposit/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询押金列表
 */
export async function listWechatDeposit(params?: WechatDepositParam) {
  const res = await request.get<ApiResult<WechatDeposit[]>>(
    MODULES_API_URL + '/shop/wechat-deposit',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加押金
 */
export async function addWechatDeposit(data: WechatDeposit) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/wechat-deposit',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改押金
 */
export async function updateWechatDeposit(data: WechatDeposit) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/wechat-deposit',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除押金
 */
export async function removeWechatDeposit(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/wechat-deposit/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除押金
 */
export async function removeBatchWechatDeposit(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/wechat-deposit/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询押金
 */
export async function getWechatDeposit(id: number) {
  const res = await request.get<ApiResult<WechatDeposit>>(
    MODULES_API_URL + '/shop/wechat-deposit/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
